package com.logicbig.example;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;

import java.math.BigInteger;
import java.util.Arrays;
import java.util.List;

@RunWith(Parameterized.class)
public class FactorialCalcTest {
    private final BigInteger inputNumber;
    private final BigInteger outputFactorial;

    public FactorialCalcTest(BigInteger inputNumber, BigInteger outputFactorial) {
        this.inputNumber = inputNumber;
        this.outputFactorial = outputFactorial;
    }

    @Parameterized.Parameters
    public static List<BigInteger[]> myParameters() {
        BigInteger[][] params = {
                param("5", "120"),
                param("7", "5040"),
                param("10", "3628800"),
                param("20", "2432902008176640000")
        };
        return Arrays.asList(params);
    }

    private static BigInteger[] param(String input, String output) {
        return new BigInteger[]{new BigInteger(input), new BigInteger(output)};
    }

    @Test
    public void testCalculator() {
        BigInteger output = FactorialCalculator.calculateFactorial(inputNumber);
        System.out.printf("Testing input: %2s, expected: %s, calculated: %s%n",
                inputNumber, outputFactorial, output);
        Assert.assertEquals(output, outputFactorial);
    }
}